"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const testing_1 = require("./../testing");
const group_1 = require("./group/group");
beforeEach(async () => {
    testing_1.Testing.reset();
    jest.resetModules();
});
test('element.ignoreError', async () => {
    const group = await testing_1.Testing.newElement(group_1.Group);
    await group.init([{
            echo: {
                ignoreError: true,
                content: '${abc}'
            }
        }]);
    const [echo] = await group.exec();
    expect(echo.error.message).toBeDefined();
});
test('element id', async () => {
    const group = await testing_1.Testing.newElement(group_1.Group);
    await group.init([{
            echo: {
                id: 'echo1',
                content: 'Echo 1'
            }
        }]);
    const [echo] = await group.exec();
    const echo1 = testing_1.Testing.vars.echo1;
    expect(echo).toBe(echo1);
});
test('get parent in loop', async () => {
    const group = await testing_1.Testing.newElement(group_1.Group);
    await group.init([
        {
            group: {
                loop: '${[1,2]}',
                runs: [
                    {
                        echo: {
                            content: '${this.parent.loopValue}'
                        }
                    }
                ]
            }
        }
    ]);
    const rs = await group.exec();
    expect(rs).toHaveLength(2);
    expect(rs[0].result[0].result).toBe(1);
    expect(rs[1].result[0].result).toBe(2);
});
//# sourceMappingURL=element-builder.spec.js.map