/// <reference types="node" />
import { IncomingMessage } from 'http';
import { FileStore } from '../../../components/file/file-store';
import { Group } from '../../../components/group/group';
import { GroupItemProps } from '../../../components/group/group.props';
import { JobHandler } from '../../../libs/queue-jobs/job-handler.interface';
import { SubJob } from './sub.job';
import { SubProps } from './sub.props';
export declare class Sub extends Group<SubProps, GroupItemProps> implements JobHandler {
    address: string;
    queue?: {
        concurrent?: number;
        file?: string;
        password?: string;
        storage?: FileStore;
    };
    private jobsManager?;
    private server?;
    constructor();
    init(props: SubProps): void;
    onJobInit(jobsData: any[]): SubJob[];
    exec(): Promise<never[]>;
    exit(): Promise<void>;
    dispose(): Promise<void>;
    getRequestBody(req: IncomingMessage): Promise<unknown>;
    private handleRequest;
}
