"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Input = void 0;
const element_shadow_1 = require("../element-shadow");
class Input extends element_shadow_1.ElementShadow {
    InputClass;
    $$ignoreEvalProps = ['input', 'InputClass'];
    props;
    input;
    constructor(InputClass) {
        super();
        this.InputClass = InputClass;
    }
    init(inputProps) {
        const { vars, title, ...props } = inputProps;
        this.vars = vars;
        this.props = { ...props, label: title };
    }
    answer(value) {
        return this.input?.answer(value);
    }
    async exec() {
        globalThis.inputIndent = this.logger.indentString;
        this.input = new this.InputClass(this.props);
        const value = await this.input.exec();
        if (value === undefined) {
            process.exit(0);
        }
        return value;
    }
}
exports.Input = Input;
//# sourceMappingURL=input.js.map