"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TagsManager = exports.ClassInFileCharacter = void 0;
const path_1 = require("path");
const modules_manager_1 = require("./modules-manager");
const packages_manager_1 = require("./packages-manager");
exports.ClassInFileCharacter = "'";
class TagsManager {
    scene;
    modules = {};
    tags = {};
    constructor(scene) {
        this.scene = scene;
    }
    register(name, pathOfModule) {
        this.modules[name] = this.scene.getPath(pathOfModule);
    }
    setTag(name, obj) {
        this.tags[name] = obj;
    }
    async getTag(name) {
        var _a;
        const path = this.modules[name];
        try {
            if (!path)
                throw new Error(`Could not found tag module "${name}"`);
            const Clazz = await (_a = path, Promise.resolve().then(() => __importStar(require(_a))));
            return Clazz;
        }
        catch (err) {
            const tag = this.tags[name];
            if (!tag)
                throw err;
            return tag;
        }
    }
    reset() {
        this.modules = {};
    }
    async loadElementClass(name, scene) {
        var _a, _b, _c;
        let ElementModule;
        const [path, className = 'default'] = name.split(exports.ClassInFileCharacter);
        let triedToInstall = false;
        do {
            const errors = [];
            do {
                try {
                    switch (errors.length) {
                        case 0:
                            ElementModule = await (_a = `../components/${path}`, Promise.resolve().then(() => __importStar(require(_a))));
                            break;
                        case 1:
                            ElementModule = await this.getTag(path);
                            break;
                        case 2:
                            ElementModule = await (_b = (0, path_1.join)(modules_manager_1.nodeModulesDir, path), Promise.resolve().then(() => __importStar(require(_b))));
                            break;
                        case 3:
                            ElementModule = await (_c = path, Promise.resolve().then(() => __importStar(require(_c))));
                            break;
                    }
                    let ElementClazz = ElementModule[className];
                    if (ElementClazz && !ElementClazz.prototype) {
                        if (typeof ElementClazz === 'function') {
                            try {
                                ElementClazz = await ElementClazz();
                            }
                            catch (err) {
                                err.$$exit = true;
                                throw err;
                            }
                        }
                        else {
                            const obj = ElementClazz;
                            ElementClazz = function () { };
                            Object.assign(ElementClazz.prototype, obj);
                        }
                    }
                    if (!ElementClazz?.prototype)
                        throw new Error(`Could not found the tag "${path}.${className}"`);
                    return ElementClazz;
                }
                catch (err) {
                    errors.push(err);
                    if (err.$$exit) {
                        throw err;
                    }
                }
            } while (errors.length < 4);
            if (triedToInstall) {
                errors.forEach((err) => scene.logger.error(err?.message));
                throw new Error(`Could not found class "${className}" in "${path}"`);
            }
            triedToInstall = true;
            const packageManager = new packages_manager_1.PackagesManager(scene);
            await packageManager.install(path);
        } while (true);
    }
}
exports.TagsManager = TagsManager;
//# sourceMappingURL=tags-manager.js.map